dnl $Id: config.m4, v 0.2 2003/08/14 09:53:01 jhannus jhannus@128kb.com Exp $
dnl config.m4 for extension opendirectory

PHP_ARG_WITH(opendirectory, for OpenDirectory support,
[  --with-opendirectory             Include OpenDirectory support])


if test "$PHP_OPENDIRECTORY" != "no"; then
	PHP_NEW_EXTENSION(opendirectory, opendirectory.c, $ext_shared)
	AC_DEFINE(HAVE_DIRECTORYSERVICES, 1, [ ])
	AC_CHECK_HEADERS([DirectoryService/DirServices.h DirectoryService/DirServicesUtils.h DirectoryService/DirServicesConst.h])

	ds_path="/System/Library/Frameworks/DirectoryService.framework/Versions/Current/Resources"
	
	lastkey="";
	for key in $(cat $ds_path/version.plist | \
	sed \
        -e '/-$/N
		{
			s/<key>\(.*\)<\/key>/ \1 /
		}'\
        -e '/-$/N
		{
			s/<string>\(.*\)<\/string>/ \1 /
		}'\
        -e '/-$/N
		{
			s/<\(.*\)>/ /
		}'); 
	do
		case $lastkey in
			*CFBundleVersion*) 
				AC_DEFINE_UNQUOTED(DS_CFBUNDLEVERSION, "$key", [DS version.plist value CFBundleVersion]);;
			*ReleaseStatus*) 
				AC_DEFINE_UNQUOTED(DS_RELEASESTATUS, "$key", [DS version.plist value ReleaseStatus]);;
			*SourceVersion*)
				AC_DEFINE_UNQUOTED(DS_SOURCEVERSION, "$key", [DS version.plist value SourceVersion]);;
			*BuildVersion*) 
				AC_DEFINE_UNQUOTED(DS_BUILDVERSION, "$key", [DS version.plist value BuildVersion]);;
		esac
		lastkey=$key;
	done

  	PHP_ADD_FRAMEWORK(DirectoryService)
fi
