/*
   +----------------------------------------------------------------------+
   | PHP Version 4                                                        |
   +----------------------------------------------------------------------+
   | Copyright (c) 1997-2003 The PHP Group                                |
   +----------------------------------------------------------------------+
   | This source file is subject to version 2.02 of the PHP license,      |
   | that is bundled with this package in the file LICENSE, and is        |
   | available at through the world-wide-web at                           |
   | http://www.php.net/license/2_02.txt.                                 |
   | If you did not receive a copy of the PHP license and are unable to   |
   | obtain it through the world-wide-web, please send a note to          |
   | license@php.net so we can mail you a copy immediately.               |
   +----------------------------------------------------------------------+
   | Authors: Justin Hannus <jhannus@128kb.com>                           |
   |                                                                      |
   +----------------------------------------------------------------------+
*/
 
/* $Id: php_opendirectory.h,v 0.2.3 2004/02/10 04:13:01 jhannus Exp $ */
#define OPENDIRECTORY_API_VERSION "20030625"

#include <DirectoryService/DirServices.h>
#include <DirectoryService/DirServicesUtils.h>
#include <DirectoryService/DirServicesConst.h>
#include "php.h"
#include "ext/standard/info.h"

#ifndef PHP_OPENDIRECTORY_H
#define PHP_OPENDIRECTORY_H


extern zend_module_entry opendirectory_module_entry;
#define phpext_opendirectory_ptr &opendirectory_module_entry

#ifdef PHP_WIN32
#define PHP_DS_API __declspec(dllexport)
#else
#define PHP_DS_API
#endif

#define DS_EXPORT(__type) PHP_DS_API __type

#ifdef ZTS
#include "TSRM.h"
#endif

ZEND_MINIT_FUNCTION(opendirectory);
ZEND_MSHUTDOWN_FUNCTION(opendirectory);
ZEND_RINIT_FUNCTION(opendirectory);
ZEND_RSHUTDOWN_FUNCTION(opendirectory);
ZEND_MINFO_FUNCTION(opendirectory);


ZEND_FUNCTION(ds_open_dir_service);
ZEND_FUNCTION(ds_open_dir_service_proxy);
ZEND_FUNCTION(ds_set_separator);
ZEND_FUNCTION(ds_get_separator);
ZEND_FUNCTION(ds_close_dir_service);
ZEND_FUNCTION(ds_verify_dir_ref_num);
ZEND_FUNCTION(ds_add_child_pid_to_reference);
ZEND_FUNCTION(ds_get_dir_node_count);
ZEND_FUNCTION(ds_get_dir_node_list);
ZEND_FUNCTION(ds_dir_status);
ZEND_FUNCTION(ds_dir_errstr);
ZEND_FUNCTION(ds_is_dir_service_running);
ZEND_FUNCTION(ds_data_buffer_alloc);
ZEND_FUNCTION(ds_data_buffer_dealloc);
ZEND_FUNCTION(ds_do_dir_node_auth);
ZEND_FUNCTION(ds_find_dir_nodes);
ZEND_FUNCTION(ds_open_dir_node);
ZEND_FUNCTION(ds_close_dir_node);
ZEND_FUNCTION(ds_get_record_list);
ZEND_FUNCTION(ds_continue_data);
ZEND_FUNCTION(ds_close_record);
ZEND_FUNCTION(ds_open_record);
ZEND_FUNCTION(ds_release_continue_data);
ZEND_FUNCTION(ds_set_record_name);
ZEND_FUNCTION(ds_set_record_type);
ZEND_FUNCTION(ds_create_record);
ZEND_FUNCTION(ds_flush_record);
ZEND_FUNCTION(ds_create_record_and_open);
ZEND_FUNCTION(ds_add_attribute);
ZEND_FUNCTION(ds_add_attribute_value);
ZEND_FUNCTION(ds_remove_attribute);
ZEND_FUNCTION(ds_remove_attribute_value);
ZEND_FUNCTION(ds_get_record_attr_value_by_index);
ZEND_FUNCTION(ds_get_record_attr_value_by_id);
ZEND_FUNCTION(ds_delete_record);
ZEND_FUNCTION(ds_get_dir_node_info);
ZEND_FUNCTION(ds_get_record_reference_info);
ZEND_FUNCTION(ds_get_record_attribute_info);
ZEND_FUNCTION(ds_do_attribute_value_search);


ZEND_BEGIN_MODULE_GLOBALS(opendirectory)
    char *separator;
    long status;
    long num_refs;
    long max_refs;
ZEND_END_MODULE_GLOBALS(opendirectory)


#ifdef ZTS
#define DS_G(v) TSRMG(opendirectory_globals_id, zend_opendirectory_globals *, v)
#else
#define DS_G(v) (opendirectory_globals.v)
#endif

#endif	/* PHP_OPENDIRECTORY_H */
